'                        LICENSE AND DISCLAIMER
'
'  This material contains IBM copyrighted sample programming source
'  code for your consideration.  This sample code has not been
'  thoroughly tested under all conditions.  IBM, therefore, cannot
'  guarantee or imply reliability, serviceability, or function.
'  IBM provides no program services for this material. This material
'  is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR
'  IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
'  FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  SOME
'  JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF IMPLIED WARRANTIES, SO
'  THE ABOVE EXCLUSIONS MAY NOT APPLY TO YOU.  IN NO EVENT WILL IBM
'  BE LIABLE TO ANY PARTY FOR ANY DIRECT, INDIRECT, SPECIAL OR OTHER
'  CONSEQUENTIAL DAMAGES FOR ANY USE OF THIS MATERIAL INCLUDING,
'  WITHOUT LIMITATION, ANY LOST PROFITS, BUSINESS INTERRUPTION, LOSS
'  OF PROGRAMS OR OTHER DATA ON YOUR INFORMATION HANDLING SYSTEM OR
'  OTHERWISE, EVEN IF EXPRESSLY ADVISED OF THE POSSIBILITY OF SUCH
'  DAMAGES.


'                           COPYRIGHT
'                           ---------
'                (C) Copyright IBM CORP. 1999
'                All rights reserved.
'                US Government Users Restricted Rights -
'                Use, duplication or disclosure restricted
'                by GSA ADP Schedule Contract with IBM Corp.
'                Licensed Material - Property of IBM

VERSION 5.00
Begin VB.Form aboutExp
   Caption         =   "About Client Access Express"
   ClientHeight    =   4980
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5715
   LinkTopic       =   "Form1"
   ScaleHeight     =   4980
   ScaleWidth      =   5715
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton okBtn
      Caption         =   "OK"
      Height          =   315
      Left            =   4440
      TabIndex        =   16
      Top             =   4560
      Width           =   1095
   End
   Begin VB.Frame Frame2
      Caption         =   "Installed Components "
      Height          =   2415
      Left            =   120
      TabIndex        =   1
      Top             =   2040
      Width           =   5415
      Begin VB.CheckBox toolkit
         Caption         =   "Toolkit"
         Height          =   375
         Left            =   2760
         TabIndex        =   11
         Top             =   1800
         Width           =   2175
      End
      Begin VB.CheckBox opConsole
         Caption         =   "Operations Console"
         Height          =   375
         Left            =   2760
         TabIndex        =   10
         Top             =   1410
         Width           =   2175
      End
      Begin VB.CheckBox prtDrivers
         Caption         =   "Printer drivers"
         Height          =   375
         Left            =   2760
         TabIndex        =   9
         Top             =   1020
         Width           =   2175
      End
      Begin VB.CheckBox pc5250
         Caption         =   "PC5250"
         Height          =   375
         Left            =   2760
         TabIndex        =   8
         Top             =   630
         Width           =   2175
      End
      Begin VB.CheckBox javaToolbox
         Caption         =   "Java Toolbox"
         Height          =   375
         Left            =   2760
         TabIndex        =   7
         Top             =   240
         Width           =   2175
      End
      Begin VB.CheckBox afpViewer
         Caption         =   "AFP Viewer"
         Height          =   375
         Left            =   120
         TabIndex        =   6
         Top             =   1800
         Width           =   2175
      End
      Begin VB.CheckBox dataAccess
         Caption         =   "Data Access"
         Height          =   375
         Left            =   120
         TabIndex        =   5
         Top             =   1410
         Width           =   2175
      End
      Begin VB.CheckBox opNav
         Caption         =   "Operations Navigator"
         Height          =   375
         Left            =   120
         TabIndex        =   4
         Top             =   1020
         Width           =   2175
      End
      Begin VB.CheckBox optComp
         Caption         =   "Optional components"
         Height          =   375
         Left            =   120
         TabIndex        =   3
         Top             =   630
         Width           =   2175
      End
      Begin VB.CheckBox expBase
         Caption         =   "Express Base"
         Height          =   375
         Left            =   120
         TabIndex        =   2
         Top             =   240
         Width           =   2175
      End
   End
   Begin VB.Frame Frame1
      Caption         =   "Version Information "
      Height          =   1815
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   5415
      Begin VB.Label ptfLevel
         Caption         =   "Service Pack:"
         Height          =   255
         Left            =   120
         TabIndex        =   15
         Top             =   1320
         Width           =   2775
      End
      Begin VB.Label level
         Caption         =   "Modification Level:"
         Height          =   255
         Left            =   120
         TabIndex        =   14
         Top             =   1000
         Width           =   2775
      End
      Begin VB.Label release
         Caption         =   "Release:"
         Height          =   255
         Left            =   120
         TabIndex        =   13
         Top             =   680
         Width           =   2775
      End
      Begin VB.Label version
         Caption         =   "Version:"
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   360
         Width           =   2775
      End
   End
End
Attribute VB_Name = "aboutExp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False


' Create ClientInfo object for retrieving version information and
' information about installed components
Dim ci As New cwbx.ClientInfo

' This routine uses the ClientInfo object to determine if the AFP
' view is installed
Private Sub afpViewer_Click()
  On Error GoTo failed

  If (ci.ComponentInstallStatus(cwbadCompAFPViewer) = True) Then
    afpViewer.Value = 1
  Else
    afpViewer.Value = 0
  End If

  Exit Sub
failed:
    errInfo.setVBInfo Err
    errInfo.Show vbModal
End Sub

' This routine uses the ClientInfo object to determine if any of the data
' access components are installed
Private Sub dataAccess_Click()
  On Error GoTo failed

  If (ci.ComponentInstallStatus(cwbadCompDataAccess) = True) Then
    dataAccess.Value = 1
  Else
    dataAccess.Value = 0
  End If

  Exit Sub
failed:
    errInfo.setVBInfo Err
    errInfo.Show vbModal
End Sub

' This routine uses the ClientInfo object to determine if the
' Client Access Express base support is installed
Private Sub expBase_Click()
  On Error GoTo failed

  If (ci.ComponentInstallStatus(cwbadCompBaseSupport) = True) Then
    expBase.Value = 1
  Else
    expBase.Value = 0
  End If

  Exit Sub
failed:
    errInfo.setVBInfo Err
    errInfo.Show vbModal
End Sub

' This routine uses the ClientInfo object to query Express version
' information.  It then calls routines, which also use the ClientInfo
' object, to determine which components are installed.
Private Sub Form_Load()
  On Error GoTo failed

  ' Query version information
  version = "Version:  " & ci.ClientVersion
  release = "Release:  " & ci.ClientRelease
  level = "Modification Level:  " & ci.ClientModificationLevel
  ptfLevel = "Service Pack: " & ci.ClientFixLevel

  ' Query the install status of Client Access Express Components
  Call expBase_Click
  Call optComp_Click
  Call opNav_Click
  Call dataAccess_Click
  Call afpViewer_Click
  Call javaToolbox_Click
  Call pc5250_Click
  Call prtDrivers_Click
  Call opConsole_Click
  Call toolkit_Click

  Exit Sub
failed:
    errInfo.setVBInfo Err
    errInfo.Show vbModal
End Sub

' This routine uses the ClientInfo object to determine if the Java
' toolbox is installed
Private Sub javaToolbox_Click()
  On Error GoTo failed

  If (ci.ComponentInstallStatus(cwbadCompJavaToolbox) = True) Then
    javaToolbox.Value = 1
  Else
    javaToolbox.Value = 0
  End If

  Exit Sub
failed:
    errInfo.setVBInfo Err
    errInfo.Show vbModal
End Sub

' This routine cancels the dialog
Private Sub okBtn_Click()
  Unload Me
End Sub

' This routine uses the ClientInfo object to determine if Operations
' Console is installed
Private Sub opConsole_Click()
  On Error GoTo failed

  If (ci.ComponentInstallStatus(cwbadCompOpConsole) = True) Then
    opConsole.Value = 1
  Else
    opConsole.Value = 0
  End If

  Exit Sub
failed:
    errInfo.setVBInfo Err
    errInfo.Show vbModal
End Sub

' This routine uses the ClientInfo object to determine if any of the
' Operations Navigator components are installed
Private Sub opNav_Click()
  On Error GoTo failed

  If (ci.ComponentInstallStatus(cwbadCompOpNav) = True) Then
    opNav.Value = 1
  Else
    opNav.Value = 0
  End If

  Exit Sub
failed:
    errInfo.setVBInfo Err
    errInfo.Show vbModal
End Sub

' This routine uses the ClientInfo object to determine if any of the Express
' optional components are installed
Private Sub optComp_Click()
  On Error GoTo failed

  If (ci.ComponentInstallStatus(cwbadCompOptionalComponents) = True) Then
    optComp.Value = 1
  Else
    optComp.Value = 0
  End If

  Exit Sub
failed:
    errInfo.setVBInfo Err
    errInfo.Show vbModal
End Sub

' This routine uses the ClientInfo object to determine if any of the
' PC5250 components are installed
Private Sub pc5250_Click()
  On Error GoTo failed

  If (ci.ComponentInstallStatus(cwbadCompPC5250) = True) Then
    pc5250.Value = 1
  Else
    pc5250.Value = 0
  End If

  Exit Sub
failed:
    errInfo.setVBInfo Err
    errInfo.Show vbModal
End Sub

' This routine uses the ClientInfo object to determine if the printer
' drivers are installed
Private Sub prtDrivers_Click()
  On Error GoTo failed

  If (ci.ComponentInstallStatus(cwbadCompPrinterDrivers) = True) Then
    prtDrive.Value = 1
  Else
    prtDrivers.Value = 0
  End If

  Exit Sub
failed:
    errInfo.setVBInfo Err
    errInfo.Show vbModal
End Sub

' This routine uses the ClientInfo object to determine if the toolkit
' is installed
Private Sub toolkit_Click()
  On Error GoTo failed

  If (ci.ComponentInstallStatus(cwbadCompToolkit) = True) Then
    toolkit.Value = 1
  Else
    toolkit.Value = 0
  End If

  Exit Sub
failed:
    errInfo.setVBInfo Err
    errInfo.Show vbModal
End Sub
