'                        LICENSE AND DISCLAIMER
'
'  This material contains IBM copyrighted sample programming source
'  code for your consideration.  This sample code has not been
'  thoroughly tested under all conditions.  IBM, therefore, cannot
'  guarantee or imply reliability, serviceability, or function.
'  IBM provides no program services for this material. This material
'  is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR
'  IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
'  FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  SOME
'  JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF IMPLIED WARRANTIES, SO
'  THE ABOVE EXCLUSIONS MAY NOT APPLY TO YOU.  IN NO EVENT WILL IBM
'  BE LIABLE TO ANY PARTY FOR ANY DIRECT, INDIRECT, SPECIAL OR OTHER
'  CONSEQUENTIAL DAMAGES FOR ANY USE OF THIS MATERIAL INCLUDING,
'  WITHOUT LIMITATION, ANY LOST PROFITS, BUSINESS INTERRUPTION, LOSS
'  OF PROGRAMS OR OTHER DATA ON YOUR INFORMATION HANDLING SYSTEM OR
'  OTHERWISE, EVEN IF EXPRESSLY ADVISED OF THE POSSIBILITY OF SUCH
'  DAMAGES.


'                           COPYRIGHT
'                           ---------
'                (C) Copyright IBM CORP. 1999
'                All rights reserved.
'                US Government Users Restricted Rights -
'                Use, duplication or disclosure restricted
'                by GSA ADP Schedule Contract with IBM Corp.
'                Licensed Material - Property of IBM

VERSION 5.00
Begin VB.Form browse
   Caption         =   "Browse"
   ClientHeight    =   3390
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5700
   LinkTopic       =   "Form1"
   ScaleHeight     =   3390
   ScaleWidth      =   5700
   StartUpPosition =   3  'Windows Default
   Tag             =   "1"
   Begin VB.ListBox objList
      Height          =   2400
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   5415
   End
   Begin VB.CommandButton okBtn
      Caption         =   "OK"
      Height          =   315
      Left            =   2400
      TabIndex        =   1
      Top             =   3000
      Width           =   975
   End
   Begin VB.Label lbTitle
      Caption         =   "User libraries:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   120
      Width           =   4335
   End
End
Attribute VB_Name = "browse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' This routine updates the listbox caption based on the type of list being
' displayed
Private Sub Form_Load()
  If (vballobj.listType = "Libraries") Then
    lbTitle.Caption = "User libraries on system " & vballobj.as400.systemName & ":"
  Else
    lbTitle.Caption = "Data queues in library " & vballobj.libName.Text & ":"
  End If
End Sub

' This routine stores the selected value in the appropriate edit box on
' the main window.  It also updates the LibraryName or the QueueName
' property, of the DataQueue object, with the new value
Private Sub okBtn_Click()
  If (objList.Text <> "") Then
    If (vballobj.listType = "Libraries") Then
      vballobj.libName.Text = objList.Text
      vballobj.dq.LibraryName = objList.Text
    Else
      vballobj.dqName.Text = objList.Text
      vballobj.dq.QueueName = objList.Text
    End If
  End If

  Unload Me
End Sub

' This function calls other routines to:
' - create an AS/400 user space (QUSCRTUS)
' - retrieve the list of AS/400 object names into the user space (QUSLOBJ)
' - retrieve the values from the user space and store them in the listbox
'   (QUSRTVUS)
' The Program object is used to call the AS/400 system APIs, in order to
' perform the actions mentioned above.  For more information on these APIs,
' see the System API Reference:
' - choose the Express Toolkit from the the Client Access Express
'   program group
' - choose Program Call
' - choose System API Reference
Public Function RetrieveObjects(objsToList As String, objContainer As String, objType As String) As Boolean
  On Error GoTo failed

  ' Create the user space, if not already created
  If (vballobj.userSpaceCreated = False) Then
    CreateUserSpace
  End If

  ' Build the list of objects
  RetrieveList objsToList, objContainer, objType

  ' Retrieve the object names from the user space
  PopulateList

  ' Signal successful completion
  RetrieveObjects = True

  Exit Function
failed:
  ' If any of the program calls failed, signal the error
  RetrieveObjects = False
End Function

' This routine creates a user space on the AS/400 to store the object
' names.  The Program object is used to call the AS/400 system API.
' The Structure, StringConverter and LongConverter objects are also
' used to convert data between AS/400 and PC formats.
Private Sub CreateUserSpace()
  Dim parms As New cwbx.ProgramParameters
  Dim currentParm As cwbx.ProgramParameter
  Dim userSpace As New cwbx.Structure
  Dim qualObjName As New cwbx.Structure
  Dim strCvtr As New cwbx.StringConverter
  Dim longCvtr As New cwbx.LongConverter

  Dim usValue(0) As Byte

  On Error GoTo failed

  ' Set the LibraryName property of the Program object
  vballobj.pgm.LibraryName = "QSYS"

  ' Set the ProgramName property of the Program object
  ' QUSCRTUS will create a user space
  ' For more information on the QUSCRTUS API and its parameters, see the
  ' System API Reference:
  ' - choose the Express Toolkit from the the Client Access Express
  '   program group
  ' - choose Program Call
  ' - choose System API Reference
  vballobj.pgm.ProgramName = "QUSCRTUS"

  ' Define parameters and set all input parameter values.

  ' Pad with blanks to 10 characters
  strCvtr.Length = 10

  ' Define structure for qualified object name
  qualObjName.Fields.Append "name", strCvtr.Length
  qualObjName.Fields.Append "library", strCvtr.Length

  Set currentParm = parms.Append("name", cwbrcInput, qualObjName.Length)
  qualObjName("name") = strCvtr.ToBytes("OBJLIST")
  qualObjName("library") = strCvtr.ToBytes("QTEMP")
  currentParm.Value = qualObjName.Bytes

  Set currentParm = parms.Append("attributes", cwbrcInput, strCvtr.Length)
  currentParm.Value = strCvtr.ToBytes("")

  Set currentParm = parms.Append("size", cwbrcInput, longCvtr.Length)
  currentParm.Value = longCvtr.ToBytes(11 * 1024)

  Set currentParm = parms.Append("value", cwbrcInput, 1)
  usValue(0) = 0
  currentParm.Value = usValue

  Set currentParm = parms.Append("authority", cwbrcInput, strCvtr.Length)
  currentParm.Value = strCvtr.ToBytes("*ALL")

  ' Pad with blanks to 50 characters
  strCvtr.Length = 50

  Set currentParm = parms.Append("description", cwbrcInput, strCvtr.Length)
  currentParm.Value = strCvtr.ToBytes("AS/400 object list")

  ' Call the AS/400 system API to create the user space
  vballobj.pgm.Call parms

  ' Signal successful completion
  vballobj.userSpaceCreated = True

  Exit Sub
failed:
  Screen.MousePointer = vbDefault

  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo vballobj.pgm.Errors
  errInfo.Show vbModal

  ' Signal the error
  Err.Raise Err.Number, Err.Source, Err.Description
End Sub

' This routine builds the list of objects and stores it in the user space.
' The Program object is used to call the AS/400 system API.
' The Structure, StringConverter and LongConverter objects are also
' used to convert data between AS/400 and PC formats.
Private Sub RetrieveList(objsToList As String, objContainer As String, objType As String)
  Dim parms As New cwbx.ProgramParameters
  Dim currentParm As cwbx.ProgramParameter
  Dim qualObjName As New cwbx.Structure
  Dim strCvtr As New cwbx.StringConverter
  Dim longCvtr As New cwbx.LongConverter

  On Error GoTo failed

  ' Set the ProgramName property of the Program object
  ' QUSLOBJ will build the object list an store it in a user space
  ' For more information on the QUSLOBJ API and its parameters, see the
  ' System API Reference:
  ' - choose the Express Toolkit from the the Client Access Express
  '   program group
  ' - choose Program Call
  ' - choose System API Reference
  vballobj.pgm.ProgramName = "QUSLOBJ"

  ' Define parameters and set all input parameter values.

  ' Pad with blanks to 10 characters
  strCvtr.Length = 10

  ' Define structure for qualified object name
  qualObjName.Fields.Append "name", strCvtr.Length
  qualObjName.Fields.Append "library", strCvtr.Length

  Set currentParm = parms.Append("user space name", cwbrcInput, qualObjName.Length)
  qualObjName("name") = strCvtr.ToBytes("OBJLIST")
  qualObjName("library") = strCvtr.ToBytes("QTEMP")
  currentParm.Value = qualObjName.Bytes

  ' Pad with blanks to 8 characters
  strCvtr.Length = 8

  Set currentParm = parms.Append("format", cwbrcInput, strCvtr.Length)
  currentParm.Value = strCvtr.ToBytes("OBJL0100")

  ' Pad with blanks to 10 characters
  strCvtr.Length = 10

  Set currentParm = parms.Append("objects to list", cwbrcInput, qualObjName.Length)
  qualObjName("name") = strCvtr.ToBytes(objsToList)
  qualObjName("library") = strCvtr.ToBytes(objContainer)
  currentParm.Value = qualObjName.Bytes

  Set currentParm = parms.Append("object type", cwbrcInput)
  currentParm.Value = strCvtr.ToBytes(objType)

  Set currentParm = parms.Append("error code", cwbrcInput)
  currentParm.Value = longCvtr.ToBytes(0)

  ' Call the AS/400 system API to retrieve the list of AS/400 objects
  vballobj.pgm.Call parms

  Exit Sub
failed:
  Screen.MousePointer = vbDefault

  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo vballobj.pgm.Errors
  errInfo.Show vbModal

  ' Signal the error
  Err.Raise Err.Number, Err.Source, Err.Description
End Sub

' This routine retrieves the object names from the user space and stores
' them in the list box.  The Program object is used to call the AS/400
' system API.  The Structure, StringConverter and LongConverter objects
' are also used to convert data between AS/400 and PC formats.
Private Sub PopulateList()
  Dim parms As New cwbx.ProgramParameters
  Dim currentParm As cwbx.ProgramParameter
  Dim qualObjName As New cwbx.Structure
  Dim strCvtr As New cwbx.StringConverter
  Dim longCvtr As New cwbx.LongConverter
  Dim userSpace As New cwbx.Structure
  Dim objectInfo As New cwbx.Structure
  Dim listCount As Long
  Dim listEntry As cwbx.StructureField
  Dim entrySize As Long

  On Error GoTo failed

  ' Set the ProgramName property of the Program object
  ' QUSRTVUS will retrieve contents of the user space
  ' For more information on the QUSRTVUS API and its parameters, see the
  ' System API Reference:
  ' - choose the Express Toolkit from the the Client Access Express
  '   program group
  ' - choose Program Call
  ' - choose System API Reference
  vballobj.pgm.ProgramName = "QUSRTVUS"

  'Define parameters and set all input parameter values

  ' Pad with blanks to 10 characters
  strCvtr.Length = 10

  ' Define structure for qualified object name
  qualObjName.Fields.Append "name", strCvtr.Length
  qualObjName.Fields.Append "library", strCvtr.Length

  Set currentParm = parms.Append("name", cwbrcInput, qualObjName.Length)
  qualObjName("name") = strCvtr.ToBytes("OBJLIST")
  qualObjName("library") = strCvtr.ToBytes("QTEMP")
  currentParm.Value = qualObjName.Bytes

  Set currentParm = parms.Append("offset", cwbrcInput, longCvtr.Length)
  currentParm.Value = longCvtr.ToBytes(1)

  Set currentParm = parms.Append("length", cwbrcInput, longCvtr.Length)
  currentParm.Value = longCvtr.ToBytes(11 * 1024)

  parms.Append "data", cwbrcOutput, 11 * 1024

  ' Call the AS/400 system API to retrieve the contents of the user space
  vballobj.pgm.Call parms

  ' Get the output parameter data into the structure
  userSpace.Bytes = parms("data").Value

  ' Define fields
  ' Skip fields that are not relevant
  userSpace.Fields.Append "", 124

  userSpace.Fields.Append "OffsetOfList", 4
  userSpace.Fields.Append "SizeOfList", 4
  userSpace.Fields.Append "NumberOfListEntries", 4
  userSpace.Fields.Append "SizeOfListEntry", 4

  ' Skip fields that are not relevant
  userSpace.Fields.Append "", _
    longCvtr.FromBytes(userSpace("OffsetOfList").Value) - userSpace.Length

  'List starts here

  ' Define structure for object information
  objectInfo.Fields.Append "Object Name", 10
  objectInfo.Fields.Append "Object Library", 10
  objectInfo.Fields.Append "Object Type", 10

  ' Strip trailing blanks
  strCvtr.Strip = True

  ' Retrieve the number of list entries and size of entry
  listCount = longCvtr.FromBytes(userSpace("NumberOfListEntries").Value)
  entrySize = longCvtr.FromBytes(userSpace("SizeOfListEntry").Value)

  ' Retrieve the object name from each entry and store it in the list box
  For i = 1 To listCount
    ' For each entry in the list, dynamically add a new list entry field
    ' to the userSpace structure and set the data of the objectInfo
    ' structure to the contents of this list entry
    Set listEntry = userSpace.Fields.Append("", entrySize)
    objectInfo.Bytes = listEntry.Value

    ' Extract the object name from the objectInfo strucutre and insert the
    ' name into the list box
    objList.AddItem strCvtr.FromBytes(objectInfo("Object Name").Value)
  Next

  Exit Sub
failed:
  Screen.MousePointer = vbDefault

  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo vballobj.pgm.Errors
  errInfo.Show vbModal

  ' Signal the error
  Err.Raise Err.Number, Err.Source, Err.Description
End Sub

