'                        LICENSE AND DISCLAIMER
'
'  This material contains IBM copyrighted sample programming source
'  code for your consideration.  This sample code has not been
'  thoroughly tested under all conditions.  IBM, therefore, cannot
'  guarantee or imply reliability, serviceability, or function.
'  IBM provides no program services for this material. This material
'  is provided "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR
'  IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
'  FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT.  SOME
'  JURISDICTIONS DO NOT ALLOW THE EXCLUSION OF IMPLIED WARRANTIES, SO
'  THE ABOVE EXCLUSIONS MAY NOT APPLY TO YOU.  IN NO EVENT WILL IBM
'  BE LIABLE TO ANY PARTY FOR ANY DIRECT, INDIRECT, SPECIAL OR OTHER
'  CONSEQUENTIAL DAMAGES FOR ANY USE OF THIS MATERIAL INCLUDING,
'  WITHOUT LIMITATION, ANY LOST PROFITS, BUSINESS INTERRUPTION, LOSS
'  OF PROGRAMS OR OTHER DATA ON YOUR INFORMATION HANDLING SYSTEM OR
'  OTHERWISE, EVEN IF EXPRESSLY ADVISED OF THE POSSIBILITY OF SUCH
'  DAMAGES.


'                           COPYRIGHT
'                           ---------
'                (C) Copyright IBM CORP. 1999
'                All rights reserved.
'                US Government Users Restricted Rights -
'                Use, duplication or disclosure restricted
'                by GSA ADP Schedule Contract with IBM Corp.
'                Licensed Material - Property of IBM

VERSION 5.00
Begin VB.Form sysInfo
   Caption         =   "AS/400 System Information"
   ClientHeight    =   5130
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6735
   LinkTopic       =   "Form1"
   ScaleHeight     =   5130
   ScaleWidth      =   6735
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton okBtn
      Caption         =   "OK"
      Height          =   315
      Left            =   3000
      TabIndex        =   12
      Top             =   4680
      Width           =   1215
   End
   Begin VB.Label totalActive
      Caption         =   "Total number of active connections:"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   4320
      Width           =   3855
   End
   Begin VB.Label dqConnected
      Caption         =   "Connected to data queues server:"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   3960
      Width           =   3855
   End
   Begin VB.Label dpcConnected
      Caption         =   "Connected to remote command/program call server:"
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   3600
      Width           =   5415
   End
   Begin VB.Label pwdExpire
      Caption         =   "Password expiration date:"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   3240
      Width           =   6375
   End
   Begin VB.Label prevSignon
      Caption         =   "Previous signon date:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   2880
      Width           =   6255
   End
   Begin VB.Label signonDate
      Caption         =   "Signon date:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   2520
      Width           =   3855
   End
   Begin VB.Label hostCodepage
      Caption         =   "Host code page:"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   2160
      Width           =   3855
   End
   Begin VB.Label userID
      Caption         =   "User ID:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1800
      Width           =   3855
   End
   Begin VB.Label hostRel
      Caption         =   "Host release:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   1440
      Width           =   6255
   End
   Begin VB.Label hostVer
      Caption         =   "Host version:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   1080
      Width           =   6135
   End
   Begin VB.Label ipAddr
      Caption         =   "IP address:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   3855
   End
   Begin VB.Label sysName
      Caption         =   "System name:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   360
      Width           =   3855
   End
End
Attribute VB_Name = "sysInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

' This routine uses the AS400System object to retrieve information about
' an AS/400 system
Private Sub Form_Load()
  On Error GoTo failed

  ' Retrieve the system name
  sysName.Caption = "System name:  " & vballobj.as400.systemName

  ' Retrieve the IP address.  If the system cannot be found, an error
  ' will be returned
  On Error Resume Next
  ipAddr.Caption = "IP address:  " & vballobj.as400.IPAddress
  If (vballobj.as400.Errors.ReturnCode <> cwbOK) Then
    ipAddr.Caption = "IP address:  (not found)"
  End If

  ' Retrieve the host version and release levels.  This information is
  ' only available after the system has been connected to a least one
  ' time.  If there is an attempt to access this information before there
  ' has been a successful connection to the system, an error will be
  ' returned
  hostVer.Caption = "Host version:  " & vballobj.as400.HostVersion
  hostRel.Caption = "Host release:  " & vballobj.as400.HostRelease
  If (vballobj.as400.Errors.ReturnCode <> cwbOK) Then
    hostVer.Caption = "Host version:  (not available before first connection to system)"
    hostRel.Caption = "Host release:  (not available before first connection to system)"
  End If
  On Error GoTo failed

  ' Retrieve the user ID used to connect to the system
  userID.Caption = "User ID:  " & vballobj.as400.userID

  ' Retrieve the host code page
  hostCodepage.Caption = "Host code page:  " & vballobj.as400.hostCodepage

  ' Retrieve signon and password expiration dates.  This information is only
  ' valid after a successful signon has occurred.  Otherwise, an error is
  ' generated.
  If (vballobj.as400.HasSignedOn = True) Then
    signonDate.Caption = "Signon date:  " & vballobj.as400.signonDate
    prevSignon.Caption = "Previous signon date:  " & vballobj.as400.PrevSignonDate
    pwdExpire.Caption = "Password expiration date:  " & vballobj.as400.PasswordExpireDate
  Else
    signonDate.Caption = "Signon date:  (not available before signon)"
    prevSignon.Caption = "Previous signon date:  (not available before signon)"
    pwdExpire.Caption = "Password expiration date:  (not available before signon)"
  End If

  ' Determine if there is an active connection to the program call server
  If (vballobj.as400.IsConnected(cwbcoServiceRemoteCmd) = 0) Then
    dpcConnected.Caption = "Connected to remote command/program call server:  False"
  Else
    dpcConnected.Caption = "Connected to remote command/program call server:  True"
  End If

  ' Determine if there is an active connection to the data queues server
  If (vballobj.as400.IsConnected(cwbcoServiceDataQueues) = 0) Then
    dqConnected.Caption = "Connected to data queues server:  False"
  Else
    dqConnected.Caption = "Connected to data queues server:  True"
  End If

  ' Retrieve the total number of active connections
  totalActive.Caption = "Total number of active connections:  " & vballobj.as400.IsConnected(cwbcoServiceAll)

  Exit Sub
failed:
  ' If a request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo vballobj.as400.Errors
  errInfo.Show vbModal
End Sub

' This routine terminates the dialog
Private Sub okBtn_Click()
  Unload Me
End Sub
