VERSION 5.00
Begin VB.Form createQ 
   Caption         =   "Create a data queue"
   ClientHeight    =   3660
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3960
   LinkTopic       =   "Form1"
   ScaleHeight     =   3660
   ScaleWidth      =   3960
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtKeySize 
      Height          =   285
      Left            =   2160
      TabIndex        =   13
      Top             =   2160
      Visible         =   0   'False
      Width           =   1095
   End
   Begin VB.CommandButton cancelBtn 
      Caption         =   "Cancel"
      Height          =   315
      Left            =   2640
      TabIndex        =   7
      Top             =   3240
      Width           =   1215
   End
   Begin VB.CommandButton createBtl 
      Caption         =   "Create"
      Default         =   -1  'True
      Height          =   315
      Left            =   1320
      TabIndex        =   6
      Top             =   3240
      Width           =   1215
   End
   Begin VB.ComboBox qAuthority 
      Height          =   315
      Left            =   2160
      TabIndex        =   3
      Text            =   "Library Create"
      Top             =   1665
      Width           =   1695
   End
   Begin VB.TextBox qDesc 
      Height          =   315
      Left            =   120
      MaxLength       =   50
      TabIndex        =   0
      Top             =   360
      Width           =   3735
   End
   Begin VB.CheckBox qForceWrite 
      Caption         =   "Force writes to storage"
      Height          =   315
      Left            =   120
      TabIndex        =   5
      Top             =   2760
      Width           =   2055
   End
   Begin VB.CheckBox qSenderInfo 
      Caption         =   "Save sender information"
      Height          =   315
      Left            =   120
      TabIndex        =   4
      Top             =   2520
      Width           =   2055
   End
   Begin VB.TextBox qMaxLength 
      Height          =   315
      Left            =   2160
      MaxLength       =   5
      TabIndex        =   2
      Text            =   "1000"
      Top             =   1260
      Width           =   1095
   End
   Begin VB.ComboBox qRtvOrder 
      Height          =   315
      Left            =   2160
      TabIndex        =   1
      Text            =   "FIFO"
      Top             =   840
      Width           =   1695
   End
   Begin VB.Label lblKeySize 
      Caption         =   "Key Size:"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   2160
      Visible         =   0   'False
      Width           =   1695
   End
   Begin VB.Label Label4 
      Caption         =   "Public authority:"
      Height          =   315
      Left            =   120
      TabIndex        =   11
      Top             =   1665
      Width           =   2055
   End
   Begin VB.Label Label3 
      Caption         =   "Maximum Record Length:"
      Height          =   315
      Left            =   120
      TabIndex        =   10
      Top             =   1260
      Width           =   2175
   End
   Begin VB.Label Label2 
      Caption         =   "Retrieval order:"
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   840
      Width           =   2055
   End
   Begin VB.Label label1 
      Caption         =   "Description:"
      Height          =   315
      Left            =   120
      TabIndex        =   8
      Top             =   120
      Width           =   3255
   End
End
Attribute VB_Name = "createQ"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public IsKeyedDQ As Boolean
' This routine terminates the dialog
Private Sub cancelBtn_Click()
  Unload Me
End Sub

' This routine uses the DataQueueAttributes and DataQueue objects to
' create a data queue on the AS/400, with characteristics (attributes)
' specified by the user.
Private Sub createBtl_Click()
  Dim dqa As New cwbx.DataQueueAttributes

  On Error GoTo failed

  ' Use the DataQueueAttributes object to set the attribute values
  ' specified by the user

  If (qDesc.Text <> "") Then
    dqa.Description = qDesc.Text
  End If

   
  dqa.MaxRecordLength = qMaxLength.Text
  dqa.ForceWritesToStorage = qForceWrite.Value
  dqa.SenderInfoSaved = qSenderInfo.Value

   If (qRtvOrder.Text = "LIFO") Then
       dqa.RetrievalOrder = cwbdqSeqLifo
   ElseIf (qRtvOrder.Text = "KEYED") Then
      dqa.RetrievalOrder = cwbdqSeqKeyed
   Else
      Debug.Assert (qRtvOrder.Text = "FIFO")
      dqa.RetrievalOrder = cwbdqSeqFifo
   End If

  If (qAuthority.Text = "All") Then
    dqa.PublicAuthority = cwbdqAll
  ElseIf (qAuthority.Text = "Exclude") Then
    dqa.PublicAuthority = cwbdqExclude
  ElseIf (qAuthority.Text = "Change") Then
    dqa.PublicAuthority = cwbdqChange
  ElseIf (qAuthority.Text = "Use") Then
    dqa.PublicAuthority = cwbdqUse
  End If

   ' Call the Create method of the DataQueue object to create the data
   ' queue on the AS/400 system
   Screen.MousePointer = vbHourglass
   If IsKeyedDQ Then
      dqa.KeySize = txtKeySize.Text
      vballobj.kdq.Create dqa
   Else
      vballobj.dq.Create dqa
   End If
   Screen.MousePointer = vbDefault
  Unload Me

  Exit Sub
failed:
  Screen.MousePointer = vbDefault

  ' If the request failed, use the Errors object to display a dialog
  ' with available error information
  errInfo.setVBInfo Err
  errInfo.setCWBInfo vballobj.dq.Errors
  errInfo.Show vbModal
End Sub

Private Sub Form_Activate()
   Init
End Sub

' This routine displays default values for the data queue attributes
Private Sub Form_Load()
   Init
End Sub
Private Sub Init()
   
   qRtvOrder.Clear
   qAuthority.Clear
   
   If IsKeyedDQ Then
      txtKeySize.Visible = True
      lblKeySize.Visible = True
      qRtvOrder.AddItem "KEYED"
   Else
      txtKeySize.Visible = False
      lblKeySize.Visible = False
      qRtvOrder.AddItem "LIFO"
      qRtvOrder.AddItem "FIFO"
   End If
  qAuthority.AddItem "All"
  qAuthority.AddItem "Exclude"
  qAuthority.AddItem "Change"
  qAuthority.AddItem "Use"
  qAuthority.AddItem "Library Create"

   qRtvOrder.ListIndex = 0
   qAuthority.ListIndex = 0
End Sub

